var Transform = require('stream').Transform;
var nodeSass = require('node-sass');
var path = require('path');

class NodeSassStream extends Transform {
  constructor (options = {}) {
    options.objectMode = true;
    super(options);
  }

  _transform (file, enc, done) {
    var fileDir = path.dirname(file.path);
    var self = this;

    nodeSass.render({
      data: file.contents.toString(),
      success: onSuccess(this, done),
      includePaths: [fileDir],
      error: function (err) {
        console.log(err);
      }
    });

  }
}

function onError (self, done) {
  return function (err) {

  }
}

function onSuccess (self, done) {
  return function (css, map) {
    console.log(css);
    self.push(css);
    done();
  }
}

export function gulpSass (options = {}) {
  return new NodeSassStream();
}
